from dataclasses import dataclass
from pathlib import Path
import numpy as np


@dataclass
class MeshObject:
    object_path: Path
    position_mm: np.ndarray
    orientation_quat: np.ndarray

    def as_dict(self):
        return dict(object_path=str(self.object_path), 
                    object_position=self.position_mm.astype(np.float64).tolist(), 
                    object_orientation=self.orientation_quat.astype(np.float64).tolist())
    
    @classmethod
    def from_dict(cls: 'MeshObject', data_dict):
        item = cls(
            Path(data_dict['object_path']), 
            np.array(data_dict['object_position']), 
            np.array(data_dict['object_orientation']))
        return item